#include "Stack.hh"

#include <exception>
#include <iostream>
using namespace std;

Stack::Stack(void) 
	: size_(chunk_),
	  data_(new int[size_]),
	  top_(-1)
{}

Stack::~Stack(void) {
	delete [] data_;
}

void Stack::push(int v) {
	if(top_>=(size_-1)) {
		resize();
	}
	data_[++top_]=v;
}

int Stack::pop(void) {
	if(top_<0) {
		throw std::exception();
	}
	return data_[top_--];
}

bool Stack::is_empty() {
	return top_<0;
}

void Stack::resize() {
	cout << "Stack::resize() current size is "<< size_ <<endl;
	int* temp=data_;
	data_=new int[size_+chunk_];
	for(int i=0;i<size_;i++) {
		data_[i]=temp[i];
	}
	size_+=chunk_;
	delete [] temp;
	cout << "Stack::resize() new size is " << size_ << endl;
}

Stack::Stack(const Stack& other) 
	: size_(other.size_),
	  data_(new int[size_]),
	  top_(other.top_)
{
	cout << "Stack::Stack(const Stack& other) called..." << endl;
	for(int i=0;i<=top_;i++) {
		data_[i]=other.data_[i];
	}
}

Stack& Stack::operator=(const Stack& other) {
	cout << "Stack& Stack::operator=(const Stack& other) called..." << endl;
	if(this!=&other) {
		delete [] data_;
		size_=other.size_;
		data_=new int[other.size_];
		top_=other.top_;
		for(int i=0;i<=top_;i++) {
			data_[i]=other.data_[i];
		}
	}
	return *this;
}










